// Code generated by go-swagger; DO NOT EDIT.

package errors

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// NewListEventsParams creates a new ListEventsParams object
// with the default values initialized.
func NewListEventsParams() ListEventsParams {

	var (
		// initialize parameters with default values

		limitDefault = int64(20)

		sortDefault = string("occurred_at_desc")
	)

	return ListEventsParams{
		Limit: &limitDefault,

		Sort: &sortDefault,
	}
}

// ListEventsParams contains all the bound params for the list events operation
// typically these are obtained from a http.Request
//
// swagger:parameters listEvents
type ListEventsParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*Base64 encoded information for pagination
	  In: query
	*/
	Cursor *string
	/*ID of the error within the project
	  Required: true
	  In: path
	*/
	Fingerprint uint32
	/*Number of entries to return
	  Maximum: 100
	  Minimum: 1
	  In: query
	  Default: 20
	*/
	Limit *int64
	/*ID of the project where the error was created
	  Required: true
	  In: path
	*/
	ProjectID uint64
	/*
	  In: query
	  Default: "occurred_at_desc"
	*/
	Sort *string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewListEventsParams() beforehand.
func (o *ListEventsParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	qs := runtime.Values(r.URL.Query())

	qCursor, qhkCursor, _ := qs.GetOK("cursor")
	if err := o.bindCursor(qCursor, qhkCursor, route.Formats); err != nil {
		res = append(res, err)
	}

	rFingerprint, rhkFingerprint, _ := route.Params.GetOK("fingerprint")
	if err := o.bindFingerprint(rFingerprint, rhkFingerprint, route.Formats); err != nil {
		res = append(res, err)
	}

	qLimit, qhkLimit, _ := qs.GetOK("limit")
	if err := o.bindLimit(qLimit, qhkLimit, route.Formats); err != nil {
		res = append(res, err)
	}

	rProjectID, rhkProjectID, _ := route.Params.GetOK("projectId")
	if err := o.bindProjectID(rProjectID, rhkProjectID, route.Formats); err != nil {
		res = append(res, err)
	}

	qSort, qhkSort, _ := qs.GetOK("sort")
	if err := o.bindSort(qSort, qhkSort, route.Formats); err != nil {
		res = append(res, err)
	}
	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindCursor binds and validates parameter Cursor from query.
func (o *ListEventsParams) bindCursor(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false

	if raw == "" { // empty values pass all other validations
		return nil
	}
	o.Cursor = &raw

	return nil
}

// bindFingerprint binds and validates parameter Fingerprint from path.
func (o *ListEventsParams) bindFingerprint(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	value, err := swag.ConvertUint32(raw)
	if err != nil {
		return errors.InvalidType("fingerprint", "path", "uint32", raw)
	}
	o.Fingerprint = value

	return nil
}

// bindLimit binds and validates parameter Limit from query.
func (o *ListEventsParams) bindLimit(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false

	if raw == "" { // empty values pass all other validations
		// Default values have been previously initialized by NewListEventsParams()
		return nil
	}

	value, err := swag.ConvertInt64(raw)
	if err != nil {
		return errors.InvalidType("limit", "query", "int64", raw)
	}
	o.Limit = &value

	if err := o.validateLimit(formats); err != nil {
		return err
	}

	return nil
}

// validateLimit carries on validations for parameter Limit
func (o *ListEventsParams) validateLimit(formats strfmt.Registry) error {

	if err := validate.MinimumInt("limit", "query", *o.Limit, 1, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("limit", "query", *o.Limit, 100, false); err != nil {
		return err
	}

	return nil
}

// bindProjectID binds and validates parameter ProjectID from path.
func (o *ListEventsParams) bindProjectID(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	value, err := swag.ConvertUint64(raw)
	if err != nil {
		return errors.InvalidType("projectId", "path", "uint64", raw)
	}
	o.ProjectID = value

	return nil
}

// bindSort binds and validates parameter Sort from query.
func (o *ListEventsParams) bindSort(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false

	if raw == "" { // empty values pass all other validations
		// Default values have been previously initialized by NewListEventsParams()
		return nil
	}
	o.Sort = &raw

	if err := o.validateSort(formats); err != nil {
		return err
	}

	return nil
}

// validateSort carries on validations for parameter Sort
func (o *ListEventsParams) validateSort(formats strfmt.Registry) error {

	if err := validate.EnumCase("sort", "query", *o.Sort, []interface{}{"occurred_at_asc", "occurred_at_desc"}, true); err != nil {
		return err
	}

	return nil
}
